package travel

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/nfs"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"
)

type travel struct {
	list string `name:"list list" help:"遍历"`
}

func (s travel) List(m *ice.Message, arg ...string) {
	m.Cmd(web.SPACE, ice.OPS, web.DREAM, web.SERVER).Table(func(value ice.Maps) {
		if len(arg) == 0 {
			m.PushRecord(value, "time,name,module,version")
		} else {
			switch value[nfs.MODULE] {
			case "2025-dev.shylinux.com/x/20250215-cluster":
				m.Cmdy(web.SPACE, value[mdb.NAME], m.PrefixKey(), arg).RewriteAppend(func(val, key string, index int) string {
					kit.If(key == web.SPACE, func() { val = kit.Keys(value[mdb.NAME], val) })
					return val
				})
			case arg[0]:
				m.Cmd(web.SPACE, value[mdb.NAME], arg[1:]).Table(func(val ice.Maps, index int, head []string) {
					m.Push(web.SPACE, value[mdb.NAME]).PushRecord(val, head...)
				})
			}
		}
	})
}

func init() { ice.Cmd("web.chat.dev.cluster.travel", travel{}) }
